## ros-humble-rmw-gurumdds-cpp 3.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rmw_gurumdds_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(gurumdds_cmake_module REQUIRED)

find_package(GurumDDS QUIET MODULE)
if(GurumDDS_FOUND)
  find_package(GurumDDS MODULE)
endif()
if(NOT GurumDDS_FOUND OR GURUMDDS_STATIC_DISABLE)
  ament_package()
  if(NOT GurumDDS_FOUND)
    message(WARNING "Could not find GurumDDS - skipping '${PROJECT_NAME}'")
  else()
    message(STATUS "GurumDDS static rmw implementation explicitly disabled - skipping '${PROJECT_NAME}'")
  endif()
  return()
endif()

find_package(rosidl_typesupport_introspection_c)
if(NOT rosidl_typesupport_introspection_c_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for GurumDDS (rosidl_typesupport_introspection_c) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rosidl_typesupport_introspection_cpp)
if(NOT rosidl_typesupport_introspection_cpp_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for GurumDDS (rosidl_typesupport_introspection_cpp) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_dds_common REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_runtime_cpp REQUIRED)

include_directories(include)
ament_export_include_directories(include ${GurumDDS_INCLUDE_DIR})
include_directories(${GurumDDS_INCLUDE_DIR})
link_directories(${GurumDDS_LIBRARY_DIRS})

add_library(rmw_gurumdds_cpp
  SHARED
  src/demangle.cpp
  src/event_converter.cpp
  src/get_entities.cpp
  src/identifier.cpp
  src/message_converter.cpp
  src/names_and_types_helpers.cpp
  src/namespace_prefix.cpp
  src/qos.cpp
  src/rmw_client.cpp
  src/rmw_compare_gids_equal.cpp
  src/rmw_count.cpp
  src/rmw_event.cpp
  src/rmw_features.cpp
  src/rmw_get_implementation_identifier.cpp
  src/rmw_get_network_flow_endpoints.cpp
  src/rmw_get_serialization_format.cpp
  src/rmw_get_topic_endpoint_info.cpp
  src/rmw_guard_condition.cpp
  src/rmw_init.cpp
  src/rmw_logging.cpp
  src/rmw_node_info_and_types.cpp
  src/rmw_node.cpp
  src/rmw_publisher.cpp
  src/rmw_qos.cpp
  src/rmw_serialize.cpp
  src/rmw_service_names_and_types.cpp
  src/rmw_service.cpp
  src/rmw_subscription.cpp
  src/rmw_topic_names_and_types.cpp
  src/rmw_wait.cpp
  src/rmw_context_impl.cpp
  src/context_listener_thread.cpp
  src/graph_cache.cpp
  src/serialization_format.cpp
  src/types.cpp
)

ament_target_dependencies(rmw_gurumdds_cpp
  "rcpputils"
  "rcutils"
  "rosidl_typesupport_introspection_c"
  "rosidl_typesupport_introspection_cpp"
  "rmw"
  "rmw_dds_common"
  "rosidl_runtime_c"
  "rosidl_runtime_cpp"
  "GurumDDS")
ament_export_libraries(rmw_gurumdds_cpp)

ament_export_dependencies(
  rosidl_typesupport_introspection_cpp
  rosidl_typesupport_introspection_c
  rosidl_runtime_c
  rosidl_runtime_cpp
  rcpputils
  rcutils
  rmw
  rmw_dds_common
)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_introspection_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_introspection_cpp")

configure_rmw_library(rmw_gurumdds_cpp)

# Causes the visibility macros to use dllexport rather than dllimport
# which is appropriate when building the library but not consuming it.
target_compile_definitions(rmw_gurumdds_cpp PRIVATE "RMW_GURUMDDS_CPP_BUILDING_LIBRARY")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package(
  CONFIG_EXTRAS_POST "rmw_gurumdds_cpp-extras.cmake"
)

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_gurumdds_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
ros-humble-rmw-gurumdds-cpp (3.4.0-1jammy) jammy; urgency=high

  * Add maintainer
  * Add null handling
  * Apply loop to take sequence
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 07 Mar 2023 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.3.1-1jammy) jammy; urgency=high

  * Remove sleep from entity creation
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 29 Nov 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.3.0-1jammy) jammy; urgency=high

  * Apply graph cache (#17 <https://github.com/ros2/rmw_gurumdds/issues/17>)
    * graph_cache 0718
    * Add topic name creation
    * graph_cache 0722
    * Sync api
    * add context::finalize()
    * Wrap-up pub and sub
    * fix gid
    * Wrap-up client and service
    * fix segfault
    * Add set on callback empty stub
    * Add content filter topic feature empty stub
    * Change the behavior of take response to a loop
    * Add missing dependency
    * Fix bug and remove unnecessary struct
    * Synk for log
    * Amend log and scope exit for node
    * Apply on_remote_changed callback & fix typo
    * Cleanup log
    * Reposition message handling timing of response
    Co-authored-by: donghee811 <mailto:donghee@gurum.cc>
  * Redefine rmw gurumdds identifier
  * Integrate rmw_gurumdds_shared_cpp into rmw_gurumdds_cpp
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 04 Oct 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.2.2-1jammy) jammy; urgency=high

  * Add missing guid comparison conditional statement
  * Add sequence numbers to message info structure
  * Contributors: Youngjin Yun, donghee811

 -- Youngjin Yun <youngjin@gurum.cc>  Mon, 04 Jul 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.2.1-1jammy) jammy; urgency=high

  * Handle null string
  * Fix rclcpp test(test_serialized_message) failure
  * Fix cast style and relative paths for cpplint
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 01 Jun 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.2.0-1jammy) jammy; urgency=high

  * Enhanced rpc with sampleinfoex
  * Basic rpc
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Mon, 25 Apr 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.1.6-1jammy) jammy; urgency=high

  * Remove minimum dds version as raw typesupport removed
  * Revert raw typesupport patch
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Mon, 25 Apr 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.1.5-1jammy) jammy; urgency=high

  * Remove dead store
  * Adjust minimum dds version
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 16 Mar 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.1.4-1jammy) jammy; urgency=high

  * Use raw typesupport instead of typesupport
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 15 Feb 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.1.3-1jammy) jammy; urgency=high

  * Add omitted free
  * Change to delete only the entities created by the user
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 15 Feb 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.1.2-1jammy) jammy; urgency=high

  * Update packages to use gurumdds-2.8 & Update README
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Sun, 02 Jan 2022 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.1.1-1jammy) jammy; urgency=high

  * Add public to qos convert api& fix for uncrustify
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Mon, 20 Dec 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.1.0-1jammy) jammy; urgency=high

  * Use convert api for publisher/subscription Qos getters
  * Add client/service Qos getters
  * Remove dds_typesupport from Publisher/Subscriber Info
  * Change the return time when destroying entities
  * Add ommited memory manage code
  * Modify unnecessary code
  * Fix typo
  * Update return value
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 24 Nov 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.9-1jammy) jammy; urgency=high



 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 13 Oct 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.8-1jammy) jammy; urgency=high



 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 13 Oct 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.7-1jammy) jammy; urgency=high



 -- Youngjin Yun <youngjin@gurum.cc>  Sun, 26 Sep 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.6-1jammy) jammy; urgency=high

  * Revise for lint
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 22 Sep 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.5-1jammy) jammy; urgency=high

  * Update rmw_context_impl_t definition
  * Add rmw_publisher_wait_for_all_acked
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 22 Sep 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.4-1jammy) jammy; urgency=high

  * Fix unbounded sequence size
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 01 Sep 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.3-1jammy) jammy; urgency=high

  * Remove datareader listener patch
  * Remove unnecessary operation
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 18 Aug 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.2-1jammy) jammy; urgency=high



 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 13 Jul 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.1-1jammy) jammy; urgency=high

  * Use variable attempt to take the number of times equal to count
  * Check if the queue is empty before using it
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 06 Jul 2021 15:00:00 -0000

ros-humble-rmw-gurumdds-cpp (3.0.0-1jammy) jammy; urgency=high

  * Revise for lint
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 28 Apr 2021 15:00:00 -0000



=== debian/control ===
Source: ros-humble-rmw-gurumdds-cpp
Section: misc
Priority: optional
Maintainer: Youngjin Yun <youngjin@gurum.cc>
Build-Depends: debhelper (>= 9.0.0), gurumdds-2.8, ros-humble-ament-cmake-ros, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-gurumdds-cmake-module, ros-humble-rcutils, ros-humble-rmw, ros-humble-rmw-dds-common, ros-humble-rosidl-cmake, ros-humble-rosidl-generator-dds-idl, ros-humble-rosidl-runtime-c, ros-humble-rosidl-runtime-cpp, ros-humble-rosidl-typesupport-introspection-c, ros-humble-rosidl-typesupport-introspection-cpp, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-rmw-gurumdds-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gurumdds-2.8, ros-humble-gurumdds-cmake-module, ros-humble-rcutils, ros-humble-rmw, ros-humble-rmw-dds-common, ros-humble-rosidl-runtime-c, ros-humble-rosidl-runtime-cpp, ros-humble-rosidl-typesupport-introspection-c, ros-humble-rosidl-typesupport-introspection-cpp, ros-humble-ros-workspace
Description: Implement the ROS middleware interface using GurumNetworks GurumDDS static code generation in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-rmw-gurumdds-cpp//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
